﻿@addTagHelper *, Microsoft.AspNetCore.Mvc.TagHelpers
@model CyberaniumModels.ClientEnablers
@using DataTables.AspNetCore.Mvc

@{
    ViewData["Title"] = "Index";
    //Layout = "~/Views/Shared/_Layout.cshtml";
}

@if (!string.IsNullOrEmpty(TempData["success"]?.ToString()))
{
    <script>
        toastr.success('@TempData["success"]');
    </script>
}
else if (!string.IsNullOrEmpty(TempData["error"]?.ToString()))
{
    <script>
        toastr.error('@TempData["error"]');
    </script>
}
<script src="~/Script/Master/Layout.js"></script>
<script>
    $(document).ready(function () {
        $('.multiple').multiselect({
            enableFiltering: true,
            includeSelectAllOption: true
        });

        if ($("#ParentOrgId").val() > 0) {
            $(".titile_heading h1").html("Enabler Assessment");
            $(".service_line").addClass("active");
            $(".assign_panel").hide();
            $(".titile_heading").show();
        } else {
            $(".titile_heading h1").html("Enabler Assessment");
            $(".service_line").removeClass("active");
            $(".assign_panel").show();
            $(".titile_heading").show();
        }
    });
    $(document).ready(function () {
        var sum = 0;
        var quantity = 0;
        $('.price').each(function () {
            var price = $(this);
            var q = price.closest('tr').find('.quantity').val();
            sum += parseInt(price.val()) * parseInt(q);
            quantity += parseInt(q);
        });

        $('#total_price').html(sum);
        $('#total_quantity').html(quantity);
    });
    function ManageOrganizationDiv(checkbox) {
        var val = parseInt($(checkbox).val());
        if (val > 0) {
            $('#divChildOrg').show();
            $('#ChildId').find('option:eq(0)').prop('selected', true);
            $('#CategoryId').find('option:eq(0)').prop('selected', true);
        } else {
            $('#divChildOrg').hide();
            $('#ChildId').find('option:eq(0)').prop('selected', true);
            $('#CategoryId').find('option:eq(0)').prop('selected', true);
        }
    }
</script>
<script src="~/Script/Master/Layout.js"></script>
<section>
    <div class="right_section">
        <div class="titile_heading" id="title_List">
            <h1>Enabler Assessment</h1>
            <div class="titile_line"></div>
        </div>
        <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">
            <div class="right_panel">
                <div class="right_content">
                    <div class="service_line" id="dvForm">
                        <form asp-area="ApplicationManagement" asp-controller="Assesment" asp-action="SubmitAssesment" id="form" method="post"
                              data-ajax="true"
                              data-ajax-method="POST"
                              data-ajax-mode="replace"
                              data-loading-text="loading..."
                              data-ajax-update="#ajaxresult"
                              data-ajax-success="fn_Onsuccess(data,'ApplicationManagement/Assesment/Index');"
                              data-ajax-failure="Errmsg(data);">
                            @Html.HiddenFor(m => m.ParentOrgId)
                            <div class="pb-2 mt-4 mb-2 border-bottom box_title">
                                Enabler Assessment
                            </div>
                            <div class="row">
                                <div class="col-12 text-center">
                                    <label>Select Organization Type</label>
                                    <div class="select_box m_bottom">
                                        <label class="col-6 text-right pr-2">
                                            <input type="radio" name="Organization" value="0" onclick="ManageOrganizationDiv(this)" checked> Parent Organization
                                        </label>
                                        <label class="col-6 text-left pl-2">
                                            <input type="radio" name="Organization" value="1" onclick="ManageOrganizationDiv(this)">  Child Organization
                                        </label>
                                    </div>
                                </div>
                            </div>
                            <div class="mb-2 border-bottom box_title"></div>
                            <div class="row">
                                <div class="col-md-4 col-sm-6 col-xs-12" style="display:none" id="divChildOrg">
                                    <label>Child Company</label>
                                    <div class="select_box m_bottom">
                                        @Html.DropDownListFor(m => m.ChildOrgId, Model.DdlOrganizations, "Select", new { @class = "form-control m_no" })
                                    </div>
                                </div>
                                <div class="col-md-4 col-sm-6 col-xs-12">
                                    <label>Category</label>
                                    <div class="select_box m_bottom">
                                        @Html.DropDownListFor(m => m.CategoryId, Model.DdlControlCat, "Select", new { @class = "form-control m_no", onchange = "fn_GetAssesmentClient(this)" })
                                    </div>
                                </div>
                            </div>
                            <div class="row">
                                @*<div class="py-5">
                                        <div class="container">
                                            <div class="row hidden-md-up">

                                            </div>
                                        </div>
                                    </div>*@
                                <div class="table_control" id="dvmultiTable">
                                    <table id="MixRegulation" class="table">
                                    </table>
                                </div>
                            </div>
                            <div class="row">
                                <div class="col-md-12 col-sm-12 col-xs-12">
                                    <div class="back_btn">
                                        <div class="back_btn_in">
                                            <input type="button" id="btnBack" name="Submit" value="Back" onclick="hideForm()">
                                        </div>
                                    </div>
                                    @*<div class="submitbtn">
                                            <input type="submit" id="btnsubmit" name="Submit" value="Submit" onclick="fnSetMultiselectValue()">
                                            <input type="reset" id="reset" value="reset" hidden />
                                        </div>*@
                                </div>
                            </div>
                        </form>
                    </div>
                    <div class="assign_panel assign_section" id="dvDataTable">
                        @*<div class="addbtn">
                                <div class="add_litigation">
                                    <span>+</span>
                                    <input type="button" id="btnHideShow" onclick="showForm()" value="Map Enablers">
                                </div>
                            </div>*@<!--edn of addbtn-->
                        <div class="assign_box active_block fade in">
                            <div class="row">
                                <div class="table_control">
                                    <table id="example2" class="table table-bordered table-hover">
                                        <thead>
                                            <tr>
                                                <th style="width:70px">SN</th>
                                                <th>Parent Organization Name</th>
                                                <th>Corporate Office Location</th>
                                                <th style="width:130px">Action</th>
                                            </tr>
                                        </thead>
                                        <tbody>
                                            @{int sn = 0;}
                                            @foreach (var item in Model.OrganizationsList)
                                            {
                                                <tr>
                                                    <td>@(++sn)</td>
                                                    <td>@item.ParentOrgName</td>
                                                    <td>@item.CorporateOfficeLocation</td>
                                                    <td>
                                                        <a data-ajax="true" data-ajax-method="GET" data-ajax-mode="replace" data-ajax-update="#ajaxresult" asp-action="Index" asp-route-OrganizationId="@item.Id" asp-controller="EnablerAssessment" asp-area="ApplicationManagement" class="edit_btn"></a>
                                                        @*<a data-ajax="true" data-ajax-method="GET" data-ajax-mode="replace" data-ajax-update="#ajaxresult" asp-action="BlockDeleteOrganization" asp-route-Id="@item.Id" asp-route-Type="0" asp-controller="Organization" asp-area="ApplicationManagement" class="Active_btn" asp-route-ActionName="@(item.IsActive ? "InActive" : "Active")"></a>*@
                                                        @*<a class="delete_btn" onclick="Confirmation('@item.Id')"></a>*@
                                                    </td>
                                                </tr>
                                            }
                                        </tbody>
                                    </table>
                                    <script>
                                        function OpenForm(Id, ParentOrgName, CorporateOfficeLocation) {
                                            $('#dvDataTable').hide();
                                            $('#dvForm').removeAttr('class');
                                            $('#labelParentOrg').text(ParentOrgName);
                                            $('#spanParentOrg').attr('onclick', 'fireTip(this,"' + ParentOrgName + '", "","' + Id + '")');
                                            $('#ParentOrg').val(Id);
                                        }
                                    </script>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</section>
<script type="text/javascript">
    $("input[type=submit]").click(function () {
        if ($("select[name=OrganizationId]").val() == "" && $("select[name=OrganizationId]").val() == 0) {
            toastr.error("select organization name");
            return false;
        } else if ($("select[name=CategoryId]").val() == null) {
            toastr.error("select a category name");
            return false;
        } else if ($("select[name=ChildOrgId]").val() == 0) {
            toastr.error("select child organization name");
            return false;
        }
    });

    function getvalue(input) {
        debugger;
        var $tblrows = $("#DomainCritical tbody tr");
        $tblrows.each(function (index) {
            var $tblrow = $(this);
        });
    }
    function showForm() {
        $('#dvDataTable').hide();
        $('#dvForm').removeAttr('class');
    }
    function hideForm() {
        $('#reset').click();
        $('#dvDataTable').show();
        $('#dvForm').attr('class', 'service_line');
    }
    function fnSetMultiselectValue() {
        var QuestionnaireXML = [];
        $('#dvmultiTable table').each(function (i, table) {
            var CategoryId = parseInt($(table).attr('id').split('_')[1]);
            var QuesArray = [], iQues = 0;
            $(table).find('thead tr:eq(1) th').each(function (i, th) {
                var quesId = parseInt($(th).attr('name'));
                if (quesId == 0) { return; }
                var AnsArray = [];
                $('.ques' + quesId).each(function (i, input) {
                    AnsArray[i] = {
                        Answer: $(input).val()
                    }
                });
                QuesArray[iQues] = {
                    QuestionId: quesId,
                    AnsArray: AnsArray
                }
                iQues++;
            });
            QuestionnaireXML[i] = {
                CategoryId: CategoryId,
                QuesArray: QuesArray
            }
        });
        $('#QuestionnaireXML').val(JSON.stringify(QuestionnaireXML));
        //console.log(QuestionnaireXML);
    }
    function fn_GetAssesmentClient(input) {
        $("#que").removeClass("hidden");
        $("#dvmultiTable").empty();
        var parentOrgId = $('#ParentOrgId').val();
        var childOrgId = $('#ChildOrgId').val() == '' ? 0 : $('#ChildOrgId').val();
        var CategoryID = $(input).val();
        var html = '<table class="table" id="tbl_' + CategoryId + '"><thead><tr>';
        $.get('/ApplicationManagement/EnablerAssessment/GetAssesmentClient', { parentOrgId: parentOrgId, childOrgId: childOrgId, categoryId: CategoryID }, function (data) {
            debugger;
            //console.log(data);
            var getEnablerQuestion = data.getEnablerQuestion;
            var GetQuestion = data.getQuestion;
            if (data.getQuestion.length > 0 && data.getEnablerQuestion.length > 0) {
                html += '<th  colspan="' + parseInt(getEnablerQuestion.length + 2) + '">' + $("#CategoryId option:selected").text() + '</th></tr>';
                html += '<tr><th name="0">SN</th>';
                $.each(GetQuestion, function (i, value) {
                    if (CategoryID == value.controlCategory) {
                        html += '<th name=' + value.id + '>' + value.query + '</th>';
                    }
                });
                html += '<th name="0">Action</th></tr></thead><tbody>';
                //for (var i = 0; i < getEnablerQuestion.length; i++) {
                //    //  $.each(getEnablerQuestion, function (i, value) { //});
                //    if (CategoryID == getEnablerQuestion[i].categoryId) {
                //        if (GetQuestion.length > i) {
                //            html += '<td><input type="text" class="form-control ques' + getEnablerQuestion[i].id + '"  value=' + getEnablerQuestion[i].answer + ' /></td>';
                //        }
                //    }
                //}
                // for (var w = 1; w <= getEnablerQuestion.length / GetQuestion.length; w++) {
                for (var w = 0; w <= getEnablerQuestion.length; w++) {
                    html += '<tr><td>' + (w + 1) + '</td>';
                    var arr = [];
                    var MatchId = getEnablerQuestion[w].questionnaireId;
                    //console.log(MatchId);
                    for (var i = 0; i < getEnablerQuestion.length; i++) {
                        if (getEnablerQuestion[i].questionnaireId == MatchId) {
                            arr.push(getEnablerQuestion[i]);
                        }
                    }
                    //var orgId = $('#OrganizationId').val();
                    for (var s = 0; s < arr.length; s++) {
                        debugger;
                        //if (getEnablerQuestion[i].questionId == GetQuestion[s].id) {
                        // html += '<td><input type="text" class="form-control ques' + arr[s].id + '"  value="' + arr[s].answer + '" /></td>';
                        html += '<td><input type="hidden" value="' + arr[s].id + '"/>' + arr[s].answer + '</td>';
                        //getEnablerQuestion.splice(i, 1);
                        //}
                        // break;
                    }
                    html += '<td><a href="#" class="edit_btn" onclick="getThreatsByIds(this,\'' + parentOrgId + '\',\'' + childOrgId + '\',\'' + CategoryID + '\')"></a></td></tr>';
                    res = jQuery.grep(getEnablerQuestion, function (a) {
                        debugger;
                        return a.questionnaireId !== getEnablerQuestion[w].questionnaireId;
                    });
                    //console.log(res);
                    getEnablerQuestion = res;
                    w = 0;
                }
                html += '</tbody></table>';
                $("#dvmultiTable").append(html);
            } else {
                toastr.error('No record found');
            }
        });
        if ($("select[name=CategoryId]").val() == null) {
            $("#que").addClass("hidden");
        }
    }
    function getThreatsByIds(a, POId, COId, CatId) {
        debugger;
        var ansId = $(a).closest('tr').find('td:eq(1) input').val();
        var ansText = $(a).closest('tr').find('td:eq(1)').text();
        $.get('/ApplicationManagement/SFDC/Index', { ParentOrgId: POId, ChildOrgId: COId, CategoryId: CatId, AnswerId: ansId }, function (data) {
            $('#ajaxresult').html(data);
            $('#title').text(ansText + ' Probability');
        });
    }
    //function fn_GetAssesmentClient(input) {
    //    $("#que").removeClass("hidden");
    //    $("#dvmultiTable").empty();
    //    var Child_Id = $("#ChildId").val()
    //    var CategoryID = $(input).val()
    //    var html = '<table class="table" id="tbl_' + CategoryID + '"><thead><tr>';
    //    $.get('/ApplicationManagement/EnablerAssessment/GetAssesmentClient', { CategoryId: CategoryID, ChildId: Child_Id }, function (data) {
    //        debugger;
    //        console.log(data);
    //        var getEnablerQuestion = data.getEnablerQuestion.data;
    //        html += '<th colspan="' + parseInt(getEnablerQuestion.length + 2) + '">' + "CategoryText" + '</th></tr>';
    //         html += '<tr><th name="0">SN</th>';
    //        $.each(getEnablerQuestion, function (i, value) {
    //           // if (CategoryID == value.categoryId) {

    //                //html += '<div class="col-md-4">' +
    //                //    '<div class="card">' +
    //                //    '<div class="card-block">';
    //                //if (value.questionId = 9) {
    //                //    html += '<h4 class="card-title">' + value.answer + '</h4>';
    //                //}
    //                //html += '<h6 class="card-subtitle text-muted">Support card subtitle</h6>' +
    //                //    '<p class="card-text p-y-1">Some quick example text to build on the card title .</p>' +
    //                //    '<a href="#" class="card-link">link</a>' +
    //                //    '<a data-ajax="true" data-ajax-method="GET" data-ajax-mode="replace" data-ajax-update="#ajaxresult" title="Normalise Risk Scores" href="/ApplicationManagement/SFDC/Index/' + value.childOrgId+'">(NRS)</a>' +
    //                //    '</div>' +
    //                //    '</div>' +
    //                //    '</div>';


    //                 html += '<th name=' + value.id + '>' + value.query + '</th>';
    //           // }
    //        });
    //        html += '<th name="0">Action</th></tr></thead><tbody><tr><td>1</td>';
    //        $.each(data, function (i, value) {
    //               html += '<td><input type="text" class="form-control ques' + value.id + '" /></td>';
    //        });
    //          html += '<td><input type="button" class="btn btn-info" value="Add" onclick="AddMoreAnswers(this)"/></td></tr></tbody></table>';
    //        $(".hidden-md-up").append(html);
    //    });

    //    if ($("select[name=CategoryId]").val() == null) {
    //        $("#que").addClass("hidden");
    //    }
    //}
    function AddMoreAnswers(input) {
        var tdLength = $(input).closest('tr').find('td').length;
        var sn = parseInt($(input).closest('tbody').find('tr:last td:eq(0)').text()) + 1;
        var html = '<tr><td>' + sn + '</td>';
        for (var i = 0; i < tdLength; i++) {
            if (i == 0 || i == tdLength - 1) { continue; }
            html += '<td>';
            html += $(input).closest('tbody').find('tr:first td').eq(i).html();
            html += '</td>';
        }
        html += '<td><input type="button" class="btn btn-danger" value="Remove" onclick="RemoveMoreAnswers(this)"></td></tr>';
        $(input).closest('tbody').append(html);
    }
    function RemoveMoreAnswers(input) {
        $(input).closest('tr').remove();
    }
    function fnUpdate(Id, CountryId, ControlCategory, Query) {
        showForm()
        $('#Id').val(Id);
        $('#CountryId').val(CountryId);
        $('#ControlCategory').val(ControlCategory);
        $('#Query').val(Query);
        $('#EventType').val(1);
    }
    function fnBlockDelete(Id, Action, Type) {
        if (confirm('Are you sure you want to ' + Action + ' this Assesment?')) {
            $.get('/ApplicationManagement/Assesment/BlockDeleteAssesment', { Id: Id, EventType: Type }, function (data) {
                debugger;
                if (data.code == 200) {
                    toastr.success(Action + ' successfully');
                    $('a[href="/ApplicationManagement/Assesment/Index"]').click();
                } else {
                    toastr.error('Something went wrong!');
                }
            });
        }
    }
    function Confirmation(id) {
        Swal.fire({
            title: 'Are you sure?',
            text: 'You want to delete this assesment',
            showCancelButton: true,
            confirmButtonText: 'Delete',
        }).then((result) => {
            /* Read more about isConfirmed, isDenied below */
            if (result.isConfirmed) {
                $('#preloader').show();
                $.ajax({
                    url: "/ApplicationManagement/Assesment/BlockDeleteAssesment",
                    type: "POST",
                    cache: false,
                    data: { Id: id, EventType: Type = 1 },
                    success: function (result) {
                        $('#preloader').hide();
                        toastr.success("Delete successfully!!");
                        $('a[href="/ApplicationManagement/Assesment/Index"]').click();
                    }, error: function (ex) {
                        console.log(ex.statusText);
                    }
                })
            }
        });
    }
    function fn_Activeincative(id, status) {
        Swal.fire({
            title: 'Are you sure?',
            text: 'You want to ' + status + ' this assesment',
            showCancelButton: true,
            confirmButtonText: status,
        }).then((result) => {
            /* Read more about isConfirmed, isDenied below */
            if (result.isConfirmed) {
                $('#preloader').show();
                $.ajax({
                    url: "/ApplicationManagement/Assesment/BlockDeleteAssesment",
                    type: "POST",
                    cache: false,
                    data: { Id: id, EventType: Type = 0 },
                    success: function (result) {
                        $('#preloader').hide();
                        toastr.success(status + " " + "successfully!!");
                        $('a[href="/ApplicationManagement/Assesment/Index"]').click();
                    }, error: function (ex) {
                        console.log(ex.statusText);
                    }
                })
            }
        });
    }
</script>